<%@ Language=VBScript %>
<%
'*******************************************************************
'* Program : Power-Stats | www.power-stats.com
'* Version : 1.0
'* Authors : Ricardo Lerch, Rodrigo Alhadeff  |  authors@power-stats.com
'* Date    : March-2004
'* Details : Views report
'*           parameters: GroupBy can be d ww m yyyy
'*******************************************************************
%>
<%
pMetaTitle="Power-Stats Page Views report"
pMetaDescription="Power-Stats Views report grouped by day week month quarter and year "
pMetaKeyWords=""
%>   

<!--#include file="power-stats-adminVerify.asp"--> 
<!--#include virtual="/power-stats/includes/settings.asp"-->    
<!--#include virtual="/power-stats/includes/databaseFunctions.asp"-->    
<!--#include virtual="/power-stats/graphicfunctions/graphicFunctions.asp"-->
<!--#include virtual="/power-stats/includes/stringFunctions.asp"--> 
<!--#include virtual="/power-stats/includes/miscFunctions.asp"--> 

<!--#include file="power-stats-header.asp"-->



<% 
' on error resume next 

dim mySQL, connTemp, rstemp


pidSite	= session("idSite")
pSiteName=session("SiteName")
'Get date data

pDateFrom=session("DateFrom")
pDateTo=session("DateTo")


pGroupBy=getUserInput(Request("GroupBy"),4)

'defaults
if pGroupBy ="" then pGroupBy="d"

pQtySubPeriods=0
pSubPeriodUnit="d"


'Calculate difference of days between DateFrom DateTo
'pQtyPeriods = datediff(pGroupBy, pDateFrom, pDateTo) +1


if not Request("DateTo")="" or pDateFrom="" then 

	if not Request("DateTo")="" then pDateTo=getUserInput(Request("DateTo"),20) 'else use session

	select case pGroupBy
		case "h" 
		
			pQtyPeriods=24 ' 24 hours zoom x-1
			pQtySubPeriods=0  
			pSubPeriodUnit="h"	
			pDateFrom=pDateTo
			
		case "d" 
			
			pDateFrom = dateadd("d", -30, pDateTo)
			pQtyPeriods=31
			
		case "ww" 
			
			pQtySubPeriods=6  '0 to 6 = 7days
			pSubPeriodUnit="d" 	
			
			pDateFrom = dateadd("ww", -11, pDateTo)
			pQtyPeriods=12
			
		case "m" 
		
			pDateFrom = dateadd("m", -11, pDateTo)
			pQtyPeriods=12
				
		case "q" 
			pQtySubPeriods=2  '0 to 2 = 3 months
			pSubPeriodUnit="m"	
			
			pDateFrom = dateadd("q", -7, pDateTo)
			pQtyPeriods=8
			
		case "yyyy" 
			
			pDateFrom = dateadd("yyyy", -3, pDateTo)
			pQtyPeriods=4
				
	end select 

else
	pQtyPeriods = datediff(pGroupBy, pDateFrom, pDateTo) + 1
end if






'debug only
'Response.Write(pQtyPeriods) & "<br>"

'Graphic Variables
gW = 700
gH = 200

'if the graphic is too small then make it bigger, at least 20 pixels per column
if gW/pQtyPeriods<20 then
	gW=pQtyPeriods*20
end if

gLayers=1 'one for views and one for visits
gValuesCount=pQtyPeriods 

gMaxVal=0
gMinVal=0


dim gValuesX()
dim gValuesY()
dim gTypes()
dim gLegends()
	
redim gValuesX(gValuesCount)
redim gValuesY(gValuesCount*gLayers)
redim gTypes(gLayers)
redim gLegends(gLayers)

 	

'ResultsTable Array
dim arrResultsTable()



ColCount=2 'qty of columns on the final report
RowCount=pQtyPeriods 'qty of Rows on the final report
redim arrResultsTable(ColCount, pQtyPeriods)

pTotalSumatory=0

'*****************************************************
'Get Views for each Period
for iPeriod=0 to pQtyPeriods-1
	pPeriodValue=0
	
	pDay = Day(DateAdd(pGroupBy,iPeriod, pDateFrom))
	pMonth = Month(DateAdd(pGroupBy,iPeriod, pDateFrom))
	pYear = Year(DateAdd(pGroupBy,iPeriod, pDateFrom))
	
	CurrDay=DateAdd(pGroupBy,iPeriod, pDateFrom)
		
	
	for iSubPeriod=0 to pQtySubPeriods
	
		'****************************************************
		' Generate SQL Query to get views for an specific period
		mySQL = "SELECT Count(logDay) AS ViewsDay"
		mySQL = mySQL &	" FROM logs "
		mySQL = mySQL &	" WHERE( (idSite=" & pidSite & ") "
		
		
		pDay = Day(DateAdd(pSubPeriodUnit,iSubPeriod, CurrDay))
		pMonth = Month(DateAdd(pSubPeriodUnit,iSubPeriod, CurrDay))
		pYear = Year(DateAdd(pSubPeriodUnit,iSubPeriod, CurrDay))
		
		
		if  pGroupBy="h" or pGroupBy="d" or pGroupBy="ww" or pGroupBy="m" or pGroupBy="q" or pGroupBy="yyyy" then
			mySQL = mySQL &	" AND (logYear=" & pYear & ") "
		end if
		if  pGroupBy="h" or pGroupBy="d" or pGroupBy="ww" or pGroupBy="m" or pGroupBy="q" then
			mySQL = mySQL &	" AND (logMonth=" & pMonth & ") "
		end if		
		if  pGroupBy="h" or pGroupBy="d" or pGroupBy="ww" then
			mySQL = mySQL &	"  AND (logDay=" & pDay & ") "
		end if
		if pGroupBy="h" then
			pHourFrom = DateAdd(pSubPeriodUnit,iPeriod, 0)
			pHourTo = DateAdd("n",59, pHourFrom)
			pHourTo = DateAdd("s",59, pHourTo)
			if instr(1,ucase(time),"M") > 0 then 'sever time is AM-PM, compare last 2 digits in logTime field
				mySQL = mySQL &	" AND (right(logTime,2)='" & mid(pHourFrom, len(pHourFrom)-1,2) & "') "
			end if
			mySQL = mySQL &	" AND (logTime>='" & pHourFrom & "') "
			mySQL = mySQL &	" AND (logTime<='" & pHourTo & "') "
		end if
		
		


		mySQL = mySQL &	")"
		
		'****************************************************
		
		
		'debug only
		'Response.Write(mySQL) & "<br>" 	
	
		call getFromDatabase(mySQL, rstemp, "views.asp")
	
		if not rstemp.EOF then
			pPeriodValue=pPeriodValue+rstemp("ViewsDay")
		end if
		
	next
	
	
	gValuesY(iPeriod)=pPeriodValue
	if gValuesY(iPeriod)>gMaxVal then gMaxVal=gValuesY(iPeriod)
	
	arrResultsTable(1,iPeriod)=gValuesY(iPeriod)
	
	pTotalSumatory=pTotalSumatory+gValuesY(iPeriod)
	
	
	'fill x values with links to zoom
	select case pGroupBy
		case "h" 
			gValuesX(iPeriod)= datepart("h", CurrDay)
			arrResultsTable(0,iPeriod)=  CurrDay  & " - " & pHourTo 
			pGroupName="Hour"
			
		case "d" 
			gValuesX(iPeriod)= "<a href='" & request.ServerVariables("URL") & "?GroupBy=h&DateTo=" & CurrDay & "' title='" & pPeriodValue & " Click to zoom'>" & pDay & "</a>"
			arrResultsTable(0,iPeriod)=CurrDay
			pGroupName="Day"
			
		case "ww" 
			
			gValuesX(iPeriod)="<a href='" & request.ServerVariables("URL") & "?GroupBy=d&DateTo=" & CurrDay & "' title='" & pPeriodValue & " Click to zoom'>" & datepart("ww", CurrDay) & "</a>"
			arrResultsTable(0,iPeriod)= "Week " & datepart("ww", CurrDay) & " of " & datepart("yyyy", CurrDay) & "  " & CurrDay
			pGroupName="Week"
			
		case "m" 
		
			linkDateTo=dateadd("m",datepart("m", CurrDay), "1/1/" & datepart("yyyy", CurrDay))
			linkDateTo=dateadd("d",-1,linkDateTo)
			gValuesX(iPeriod)="<a href='" & request.ServerVariables("URL") & "?GroupBy=ww&DateTo=" & linkDateTo & "'  title='" & pPeriodValue & " Click to zoom'>" & pMonth & "</a>"
			arrResultsTable(0,iPeriod)=datepart("m", CurrDay) & "/" & datepart("yyyy", CurrDay)
			pGroupName="Month"
			
		case "q" 
			
			linkDateTo=dateadd("q",datepart("q", CurrDay), "1/1/" & datepart("yyyy", CurrDay))
			linkDateTo=dateadd("d",-1,linkDateTo)
		
			gValuesX(iPeriod)="<a href='" & request.ServerVariables("URL") & "?GroupBy=m&DateTo=" & linkDateTo & "' title='" & pPeriodValue & " Click to zoom'>" & datepart("q", CurrDay)  & "</a>"
			arrResultsTable(0,iPeriod)= "Quarter " & datepart("q", CurrDay) & " of " & datepart("yyyy", CurrDay)
			pGroupName="Quarter"
	
		case "yyyy" 
			
			linkDateTo=dateadd("yyyy",1, "1/1/" & datepart("yyyy", CurrDay))
			linkDateTo=dateadd("d",-1,linkDateTo)
			
			gValuesX(iPeriod)="<a href='" & request.ServerVariables("URL") & "?GroupBy=q&DateTo=" & linkDateTo & "' title='" & pPeriodValue & " Click to zoom'>" & pYear & "</a>"
			arrResultsTable(0,iPeriod)=datepart("yyyy", CurrDay)
			pGroupName="Year"
			
	end select 
	
next
' end Get Views for each Period
'*****************************************************



gMaxVal = gMaxVal * 1.15 'make graphic height, x% bigger than the maxval

if gMaxVal = 0 then gMaxVal = 1 'if all values are 0

'set all layers to columns
gTypes(0)=1

'legends
gLegends(0)= "<a href='" & pWorkingURL & "'>" & pWorkingURL & "</a></b><br>" & "Page Views <br> From: " & pDateFrom & "<br> To  : " & pDateTo & "<br>"  

gFirstColor=0

%>
<!--#include file="power-stats-inc-DisplayFilterInfo.asp"-->

<!--#include file="power-stats-inc-DisplayMenuHtoY.asp"-->


<br>
	
	<center>
	<table id="tableResults"  cellspacing="0" cellpadding="0">
	<tr><td id="tdResultsHeader" colspan="<%=ColCount%>"></td></tr>
	<tr><td id="tdResultsTitle" colspan="<%=ColCount%>">Page Views Graphic - By <%=pGroupName%> - Displaying <%=pQtyPeriods%> Periods <br>Views[Avg:<%Response.Write(round(pTotalSumatory/RowCount,0))%> Sum:<%=pTotalSumatory%>]</td></tr>
	<tr><td id="tdResultsSubTitle" colspan="<%=ColCount%>"><%=pSiteName%></td></tr>
	<tr><td id="tdResultsText" colspan="<%=ColCount%>"><br> 
<%


call DrawChart(gW, gH, gLayers, gValuesCount, gMaxVal, gMinVal, gTypes, gValuesY, gValuesX, gLegends, gFirstColor)


%>
</td></tr>

	<tr><td id="tdResultsFooter" colspan="<%=ColCount%>"></td></tr>
	  
	</table>
	</center>
	


<br>
	  

		
	<center>
	
	<table id="tableResults" cellspacing="0" cellpadding="0">
	<tr><td id="tdResultsHeader" colspan="<%=ColCount%>"></td></tr>
	<tr><td id="tdResultsTitle" colspan="<%=ColCount%>">Page Views Data Report - By <%=pGroupName%> - Displaying <%=pQtyPeriods%> Periods <br>Views[Avg:<%Response.Write(round(pTotalSumatory/RowCount,0))%> Sum:<%=pTotalSumatory%>]</td></tr>
	<tr><td id="tdResultsSubTitle" colspan="<%=ColCount%>"><%=pSiteName%></td></tr>
	<tr><td id="tdResultsText" colspan="<%=ColCount%>"></td></tr>
	<%
		
		
		'Write Column Headers
		
		Response.Write "<td id='tdResultsColumnHeader'>Date</td>"
		Response.Write "<td id='tdResultsColumnHeader'>Page Views</td>"
		
	
				
		tdRow = 1
		for iRow=0 to RowCount-1
			tdRow = tdRow * -1
			Response.Write "<tr>"
			for iCol=0 to ColCount -1
				Response.Write "<td id='tdResultsLine" &tdRow& "'>" & arrResultsTable(iCol,iRow)  & "&nbsp;</td>"
			next
			Response.Write "</tr>"
		next

	%>
	  
	<tr><td id="tdResultsFooter" colspan="<%=ColCount%>"></td></tr>
	  
	</table>
	</center>
	<br>  



	
<%
call closeDb()
%>
<!--#include file="power-stats-footer.asp"-->